include masm32rt.inc
.686p
.mmx
.xmm

IDT_ROTATION	EQU	100

WndProc proto hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
RotateBitBltAtD proto hDestDC:HDC,hSrcDC:HDC,xCenter:DWORD,yCenter:DWORD,angle:REAL4,destRect:RECT,xSrc:DWORD,ySrc:DWORD
RotateBitBltAtR proto hDestDC:HDC,hSrcDC:HDC,xCenter:DWORD,yCenter:DWORD,angle:REAL4,destRect:RECT,xSrc:DWORD,ySrc:DWORD
GdiSetRot proto hDC:HDC,radAngle:REAL4,xCenter:DWORD,yCenter:DWORD

WND_DATA struct
	angle		REAl4	?	; current rotation angle in degree
	hdc			HDC		?	; back buffer
	hdcImage	HDC		?	; image
	bmp			HBITMAP	?
	bmpImage	HBITMAP	?
WND_DATA ends

.data?
	hInstance	dd ?
.code
main proc 
LOCAL wcex:WNDCLASSEX
LOCAL msg:MSG

	mov hInstance,rv(GetModuleHandle,0)
	mov wcex.hInstance,eax
	mov wcex.cbSize,SIZEOF WNDCLASSEX
	mov wcex.style, CS_HREDRAW or CS_VREDRAW
	mov wcex.lpfnWndProc, OFFSET WndProc
	mov wcex.cbClsExtra,NULL
	mov wcex.cbWndExtra,SIZEOF WND_DATA
	mov wcex.hbrBackground,0
	mov wcex.lpszMenuName,NULL
	mov wcex.lpszClassName,chr$("win32class")
	mov wcex.hIcon,rv(LoadIcon,NULL,IDI_APPLICATION)
	mov wcex.hIconSm,eax
	mov wcex.hCursor,rv(LoadCursor,NULL,IDC_ARROW)
	invoke RegisterClassEx, ADDR wcex
	mov esi,rv(CreateWindowEx,0,wcex.lpszClassName,"SetWorldTransform-Example, rotate DC at specified position",WS_VISIBLE or WS_SYSMENU,CW_USEDEFAULT,CW_USEDEFAULT,500,400,0,0,hInstance,0)

	.while 1
		invoke GetMessage,ADDR msg,NULL,0,0
		.break .if !eax || eax == -1
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw

	invoke ExitProcess,msg.wParam

main endp

WndProc proc uses ebx esi edi hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM
LOCAL ps:PAINTSTRUCT
LOCAL rect:RECT
LOCAL angle:REAL4
LOCAL cxScreen:DWORD
LOCAL cyScreen:DWORD
LOCAL sz[128]:CHAR
LOCAL double:REAL8

	.if uMsg == WM_CLOSE
		invoke PostQuitMessage,NULL
	.elseif uMsg == WM_DESTROY
		; delete Bimtaps and DCs
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.bmp))
		invoke DeleteDC,ebx
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdcImage)
		invoke DeleteObject,rv(SelectObject,ebx,rv(GetWindowLong,hWnd,WND_DATA.bmpImage))
		invoke DeleteDC,ebx
	.elseif uMsg == WM_CREATE

		; create back buffer for drawing
		mov cxScreen,rv(GetSystemMetrics,SM_CXSCREEN)
		mov cyScreen,rv(GetSystemMetrics,SM_CYSCREEN)
		mov esi,rv(GetDC,rv(GetDesktopWindow))
		mov ebx,rv(CreateCompatibleDC,esi)
		invoke SetWindowLong,hWnd,WND_DATA.bmp,rv(SelectObject,ebx,rv(CreateCompatibleBitmap,esi,cxScreen,cyScreen))
		invoke SetWindowLong,hWnd,WND_DATA.hdc,ebx
		invoke BitBlt,ebx,0,0,cxScreen,cyScreen,ebx,0,0,PATCOPY
		
		; load a bitmap file (200x131 Pixels)
		mov ebx,rv(CreateCompatibleDC,esi)
		.if !rv(LoadImage,hInstance,"image",IMAGE_BITMAP,0,0,LR_DEFAULTSIZE)
			invoke MessageBeep,0FFFFFFFFh
			invoke ExitProcess,0
		.endif
		invoke SetWindowLong,hWnd,WND_DATA.bmpImage,rv(SelectObject,ebx,eax)
		invoke ReleaseDC,rv(GetDesktopWindow),esi
		invoke SetWindowLong,hWnd,WND_DATA.hdcImage,ebx
		
		invoke SetTimer,hWnd,IDT_ROTATION,20,0
		
	.elseif uMsg == WM_TIMER
		.if wParam == IDT_ROTATION
			mov edi,rv(GetWindowLong,hWnd,WND_DATA.hdc)
			mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdcImage)
			mov angle,rv(GetWindowLong,hWnd,WND_DATA.angle)
			invoke GetClientRect,hWnd,ADDR rect
			
			; clear DC's background with white brush
			invoke BitBlt,edi,0,0,rect.right,rect.bottom,edi,0,0,PATCOPY

			; Draw image at position (100|100) and rotate it around position (200|165)=image center.
			; The angle is in degree.
			mov rect.left,100
			mov rect.top,100
			mov rect.right,100+200
			mov rect.bottom,100+131
			invoke RotateBitBltAtD,edi,ebx,100+100,100+65,angle,rect,0,0
			
			; print text
			fld angle
			fstp double
			fn crt_sprintf,ADDR sz,"rotation: %.1f",double
			invoke TextOut,edi,0,0,ADDR sz,len(ADDR sz)
			
			; update angle
			fld angle
			fadd FP4(1.0)
			fstp angle
			invoke SetWindowLong,hWnd,WND_DATA.angle,angle
			invoke InvalidateRect,hWnd,0,0
		.endif
	.elseif uMsg == WM_PAINT
		invoke BeginPaint,hWnd,ADDR ps
		mov ebx,rv(GetWindowLong,hWnd,WND_DATA.hdc)
		mov edx,ps.rcPaint.right
		sub edx,ps.rcPaint.left
		mov ecx,ps.rcPaint.bottom
		sub ecx,ps.rcPaint.top
		invoke BitBlt,ps.hdc,ps.rcPaint.left,ps.rcPaint.top,edx,ecx,ebx,ps.rcPaint.left,ps.rcPaint.top,SRCCOPY
		invoke EndPaint,hWnd,ADDR ps
	.else
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.endif

	xor eax,eax
	ret
WndProc endp

; destRect = rectangle to be rotated at position (xCenter|yCenter) in destination DC
; [angle]=degree
RotateBitBltAtD proc uses edi esi ebx hDestDC:HDC,hSrcDC:HDC,xCenter:DWORD,yCenter:DWORD,angle:REAL4,destRect:RECT,xSrc:DWORD,ySrc:DWORD
LOCAL xfrm:XFORM
LOCAL mode:DWORD

	; degree -> radian
	fld angle
	fmul FP4(0.01745329) ;pi/180
	fstp angle
	
	; save current graphic mode
	mov mode,rv(GetGraphicsMode,hDestDC)

	; set required graphic mode
	invoke SetGraphicsMode,hDestDC,GM_ADVANCED
	
	; save current world transform
	invoke GetWorldTransform,hDestDC,ADDR xfrm
	
	; set new world transform
	invoke GdiSetRot,hDestDC,angle,xCenter,yCenter
	
	; copy to rotated rectangle in dest-DC
	mov ecx,destRect.right
	mov edx,destRect.bottom
	sub ecx,destRect.left
	sub edx,destRect.top
	invoke BitBlt,hDestDC,destRect.left,destRect.top,ecx,edx,hSrcDC,xSrc,ySrc,SRCCOPY

	; restore previous world transform
	invoke SetWorldTransform,hDestDC,ADDR xfrm
	
	; restore previous graphic mode
	invoke SetGraphicsMode,hDestDC,mode
	
	mov eax,1
	ret
	
RotateBitBltAtD endp

; [angle]=radian
RotateBitBltAtR proc uses edi esi ebx hDestDC:HDC,hSrcDC:HDC,xCenter:DWORD,yCenter:DWORD,angle:REAL4,destRect:RECT,xSrc:DWORD,ySrc:DWORD
LOCAL xfrm:XFORM
LOCAL mode:DWORD

	mov mode,rv(GetGraphicsMode,hDestDC)
	invoke SetGraphicsMode,hDestDC,GM_ADVANCED
	invoke GetWorldTransform,hDestDC,ADDR xfrm
	invoke GdiSetRot,hDestDC,angle,xCenter,yCenter
	mov ecx,destRect.right
	mov edx,destRect.bottom
	sub ecx,destRect.left
	sub edx,destRect.top
	invoke BitBlt,hDestDC,destRect.left,destRect.top,ecx,edx,hSrcDC,xSrc,ySrc,SRCCOPY
	invoke SetWorldTransform,hDestDC,ADDR xfrm
	invoke SetGraphicsMode,hDestDC,mode
	
	mov eax,1
	ret
	
RotateBitBltAtR endp


GdiSetRot proc hDC:HDC,radAngle:REAL4,xCenter:DWORD,yCenter:DWORD
LOCAL xform:XFORM
	
	fld radAngle
	fchs
	fsincos
	fld st
	fstp REAL4 ptr xform.eM11
	fld st(1)
	fstp REAL4 ptr xform.eM12
	fld st(1)
	fchs
	fstp REAL4 ptr xform.eM21
	fld st
	fstp REAL4 ptr xform.eM22

	fld st(1)
	fld st(1)
	fimul xCenter
	fchs
	fiadd xCenter
	fxch
	fimul yCenter
	faddp st(1),st
	fstp REAL4 ptr xform.ex
	
	fimul yCenter
	fchs
	fiadd yCenter
	fxch
	fimul xCenter
	fsubp st(1),st
	fstp REAL4 ptr xform.ey
	
;	fSlv xform.eM11 =  cos(-radAngle)
;	fSlv xform.eM12 =  sin(-radAngle)
;	fSlv xform.eM21 = -sin(-radAngle)
;	fSlv xform.eM22 =  cos(-radAngle)
;	fSlv xform.ex = xCenter - cos(-radAngle)*xCenter + sin(-radAngle)*yCenter
;	fSlv xform.ey = yCenter - cos(-radAngle)*yCenter - sin(-radAngle)*xCenter
	
	invoke SetWorldTransform,hDC,ADDR xform
	
	ret

GdiSetRot endp


end main
